<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDriverPoiItem ArrayType
 * @subpackage Arrays
 */
class ArrayOfDriverPoiItem extends AbstractStructArrayBase
{
    /**
     * The DriverPoiItem
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DriverPoiItem[]
     */
    public $DriverPoiItem;
    /**
     * Constructor method for ArrayOfDriverPoiItem
     * @uses ArrayOfDriverPoiItem::setDriverPoiItem()
     * @param \StructType\DriverPoiItem[] $driverPoiItem
     */
    public function __construct(array $driverPoiItem = array())
    {
        $this
            ->setDriverPoiItem($driverPoiItem);
    }
    /**
     * Get DriverPoiItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DriverPoiItem[]|null
     */
    public function getDriverPoiItem()
    {
        return isset($this->DriverPoiItem) ? $this->DriverPoiItem : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDriverPoiItem method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDriverPoiItem method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDriverPoiItemForArrayConstraintsFromSetDriverPoiItem(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDriverPoiItemDriverPoiItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfDriverPoiItemDriverPoiItemItem instanceof \StructType\DriverPoiItem) {
                $invalidValues[] = is_object($arrayOfDriverPoiItemDriverPoiItemItem) ? get_class($arrayOfDriverPoiItemDriverPoiItemItem) : sprintf('%s(%s)', gettype($arrayOfDriverPoiItemDriverPoiItemItem), var_export($arrayOfDriverPoiItemDriverPoiItemItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DriverPoiItem property can only contain items of type \StructType\DriverPoiItem, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DriverPoiItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DriverPoiItem[] $driverPoiItem
     * @return \ArrayType\ArrayOfDriverPoiItem
     */
    public function setDriverPoiItem(array $driverPoiItem = array())
    {
        // validation for constraint: array
        if ('' !== ($driverPoiItemArrayErrorMessage = self::validateDriverPoiItemForArrayConstraintsFromSetDriverPoiItem($driverPoiItem))) {
            throw new \InvalidArgumentException($driverPoiItemArrayErrorMessage, __LINE__);
        }
        if (is_null($driverPoiItem) || (is_array($driverPoiItem) && empty($driverPoiItem))) {
            unset($this->DriverPoiItem);
        } else {
            $this->DriverPoiItem = $driverPoiItem;
        }
        return $this;
    }
    /**
     * Add item to DriverPoiItem value
     * @throws \InvalidArgumentException
     * @param \StructType\DriverPoiItem $item
     * @return \ArrayType\ArrayOfDriverPoiItem
     */
    public function addToDriverPoiItem(\StructType\DriverPoiItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DriverPoiItem) {
            throw new \InvalidArgumentException(sprintf('The DriverPoiItem property can only contain items of type \StructType\DriverPoiItem, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DriverPoiItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DriverPoiItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DriverPoiItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DriverPoiItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DriverPoiItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DriverPoiItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DriverPoiItem
     */
    public function getAttributeName()
    {
        return 'DriverPoiItem';
    }
}
